1
2

Delete article

Deleted articles cannot be recovered.

Draft of this article would be also deleted.

Are you sure you want to delete this article?

More than 5 years have passed since last update.

SketchUp Make v17 / Ruby > Groupを座標の(0,0,0)に移動する

Last updated at Posted at 2016-12-30
動作環境
SketchUp Make v17.1.173
MacOS X El Capitan

関連 http://qiita.com/7of9/items/ff5921cf65b5f88d9311

選択したGroupを座標(0,0,0)に移動してみる。

参考(Group) http://ruby.sketchup.com/Sketchup/Group.html
originというプロパティを参考にした。

参考(Point3d) http://ruby.sketchup.com/Geom/Point3d.html
originはPoint3d型のようだ。

code

Groupの位置(origin)を取得して、その反対の大きさの移動をするという方針。

align161230.rb
require 'sketchup.rb'

def align_group_to_worldOrigin()
    model = Sketchup.active_model
    my_selection = model.selection

    my_selection.each do |ent|
        if ent.is_a? Sketchup::Group
            tr = ent.transformation
            org = tr.origin # :Point3d
            pnt = Geom::Point3d.new(-org[0], -org[1], -org[2])
    	    mve = Geom::Transformation.new(pnt)
            ent.transform! mve
        end
    end
end

移動前

qiita.png

移動後

qiita.png

1
2
0

Register as a new user and use Qiita more conveniently

  1. You get articles that match your needs
  2. You can efficiently read back useful information
  3. You can use dark theme
What you can do with signing up
1
2

Delete article

Deleted articles cannot be recovered.

Draft of this article would be also deleted.

Are you sure you want to delete this article?